//
//  GlkGlyphGenerator.m
//  CocoaGlk
//
//  Created by Andrew Hunter on 10/09/2006.
//  Copyright 2006 Andrew Hunter. All rights reserved.
//

#import "GlkGlyphGenerator.h"
#import "GlkImage.h"


@implementation GlkGlyphGenerator

- (void) generateGlyphsForGlyphStorage: (id <NSGlyphStorage>) glyphStorage
			 desiredNumberOfCharacters: (unsigned int) nChars
							glyphIndex: (unsigned int *) glyphIndex 
						characterIndex: (unsigned int *) charIndex {
	NSAttributedString* str = [glyphStorage attributedString];
	
	//int start = *charIndex;
	int pos = *charIndex;
	int end = pos + nChars;
	
	// Iterate through str
	NSRange range;
	
	while (pos < end) {
		// Get the attributes for this section
		NSDictionary* attr = [str attributesAtIndex: pos
									 effectiveRange: &range];
		if (pos + range.length > end) {
			range.length = end-pos;
		}
		
		// Perform an action based on these attributes
		if ([attr objectForKey: GlkImageAttribute] != nil) {
			// Add a control glyph
			NSGlyph control = NSControlGlyph;
			
			[glyphStorage insertGlyphs: &control
								length: 1
			   forStartingGlyphAtIndex: *glyphIndex
					   characterIndex: pos];
			(*glyphIndex)++;
			(*charIndex) = pos+range.length;
		} else {
			// Use the standard layout for this range
			[[NSGlyphGenerator sharedGlyphGenerator] generateGlyphsForGlyphStorage: glyphStorage
														 desiredNumberOfCharacters: range.length
																		glyphIndex: glyphIndex
																	characterIndex: charIndex];
		}
		
		pos += range.length;
	}
}

@end
